#include "Fireball.h"
#include "LD37.h"

extern LD37* game;

Fireball::Fireball(ALLEGRO_BITMAP* g) : Entity(g)
{
	solid = true;
	layer = 550;
	liftable = false;
	srcx = 48;
	srcy = 32;
	thrown = true;
	diddly = true;
	killMe = false;
	angle = 0;
}

void Fireball::Update()
{
	if (game->nTurns > tc + 1 && tc != 0)
	{
		cout << "ONE OF THE FIREBALLS REFUSED TO MOVE. PLEASE NOTIFY THE PROGRAMMER." << endl;
	}
	Entity::Update();
	if (diddly)
	{
		int ppx = x;
		int ppy = y;
		x += thx;
		y += thy;
		if (CanWalk(x, y, true, true) == false)
		{
			killMe = true;
			Particle* p = new Particle(graphic, 48, 0, 3, 5);
			p->x = x;
			p->y = y;
			game->AddEnt(p);
			p = nullptr;
		}
	}
	else
	{
		diddly = true;
	}
	tc = game->nTurns;
}

void Fireball::Render()
{
	Entity::HandleTransition();
	angle += 0.2f;
	al_draw_tinted_scaled_rotated_bitmap_region(graphic, srcx, srcy, 16, 16, al_map_rgb(255, 255, 255), 8, 8, tx + 8, ty + 8, 1.0f, 1.0f, angle, 0);
}

Fireball::~Fireball()
{
}
